#!/usr/bin/env python

"""
XSL-based form templating.
"""

import libxslt

"""
import libxml2

def quiet(context, s):
    pass

libxml2.registerErrorHandler(quiet, None)
"""

def path_to_node(node):

    "Generate an XSLForms path to the given 'node'."

    l = []
    # Attribute reference.
    l.insert(0, node.name)
    l.insert(0, "/")
    node = node.parent
    # Element references.
    while node is not None and node.type != "document_xml":
        l.insert(0, str(int(node.xpathEval("count(preceding-sibling::*) + 1"))))
        l.insert(0, "#")
        l.insert(0, node.name)
        l.insert(0, "/")
        node = node.parent
    return "".join(l)

def this_position(context):

    """
    As a libxslt extension function, return a string containing the XSLForms
    path to the 'context' node.
    """

    pctxt = libxslt.xpathParserContext(_obj=context)
    context = pctxt.context()
    node = context.contextNode()
    return path_to_node(node)

libxslt.registerExtModuleFunction("this-position", "http://www.boddie.org.uk/ns/xmltools/template", this_position)

# vim: tabstop=4 expandtab shiftwidth=4
